UNIT EDFile;
{ Epic Delusions MM Libs: File IO v0.5                     }
{ Copyright 1998 Orlando Llanes aka WundrDawg              }
{ File IO and Resource File IO objects                     }
{ History:                                                 }
{  05/31/98 v0.5   Started coding                          }

INTERFACE

USES
  EDSys, EDDef;

CONST
  fmRead         = "r";
  fmWrite        = "w";
  fmReadWrite    = "rw";

TYPE
  PFileIO = ^TFileIO;
  TFileIO = OBJECT
    Handle   : Pointer;
    FMode,
    Name     : EDStrZ;
    IOResult : Integer;

    CONSTRUCTOR Open( zFName, zFMode : EDStrZ; zBufSize : EDUInt32 );

    FUNCTION GetPos: EDUInt32; Virtual;
    PROCEDURE SetPos( zNewPos : EDUInt32 ); Virtual;

    FUNCTION BlockRead( VAR zOutBuf; zBytes : EDUInt32 ): EDUInt32; Virtual;
    FUNCTION BlockWrite( VAR zInBuf; zBytes : EDUInt32 ): EDUInt32; Virtual;

    DESTRUCTOR Close; Virtual;
  END;

IMPLEMENTATION

  CONSTRUCTOR TFileIO.Open( zFName, zFMode : EDStrZ; zBufSize : EDUInt32 );
  BEGIN
    IOResult := -1;

    IF Handle <> NIL THEN
      IF fclose( Handle ) THEN;

    Handle := fopen( zFName, zFMode );
    IF Handle <> NIL THEN
    BEGIN
      IOResult := 0;
      Name     := zFName;
    END;
  END;

  FUNCTION TFileIO.GetPos mFilePos: EDInt32;
  BEGIN
    mFilePos := $FFFFFFFF;
    IOResult := -1;

    IF fgetpos( Handle, mFilePos ) THEN
      IOResult := 0;
  END;

  PROCEDURE TFileIO.SetPos( zNewPos : EDUInt32 );
  BEGIN
    IOResult := -1;

    IF fseek( Handle, zNewPos, fsSeekSet ) THEN
      IOResult := 0;
  END;

  FUNCTION TFileIO.BlockRead( VAR zOutBuf; zBytes : EDUInt32 )
    mActualRead: EDUInt32;
  BEGIN
    IOResult := -1;

    mActualRead := fread( @zOutBuf, 1, zBytes, Handle );
    IF mActualRead <> 0 THEN
      IOResult := 0;
  END;

  FUNCTION TFileIO.BlockWrite( VAR zInBuf; zBytes : EDUInt32 )
    mActualWritten: EDUInt32;
  BEGIN
    IOResult := -1;

    mActualWritten := fwrite( @zInBuf, 1, zBytes, Handle );
    IF mActualWritten <> 0 THEN
      IOResult := 0;
  END;

  DESTRUCTOR TFileIO.Close;
  BEGIN
    IOResult := -1;
    IF fclose( Handle ) THEN
      IOResult := 0;
  END;

END.
