UNIT PCX;

{ PcxEncode based on savePCX by Peter Cellik from the }
{ Sphynx C-- compiler, file PCX.H--                   }

INTERFACE

USES
  EDSys, EDFile;

TYPE
  PArray8 = ^TArray8;
  TArray8 = ARRAY[ 0..0 ] OF Byte;

  TPal = ARRAY[ 1..768 ] OF Byte;

  PCXHeader = PACKED RECORD
    Mfg,
    Ver,
    Encoding,
    BPP        : Byte;
    X,   Y,
    X2, Y2,
    XRes, YRes : ShortCard;
    EGAPal     : ARRAY[ 1..48 ] OF Byte;
    Rsvd,
    NumPlanes  : Byte;
    BPL,
    PalType    : ShortCard;
    Padding    : ARRAY[ 1..58 ] OF Byte;
  END;

  PROCEDURE PcxEncode( F : PFileIO; zWidth, zHeight : Word;
    Buf : PArray8; zPal : TPal );

IMPLEMENTATION

  PROCEDURE PcxEncode( F : PFileIO; zWidth, zHeight : Cardinal;
    Buf : PArray8; zPal : TPal );
  VAR
    H       : PCXHeader;
    mResult : Cardinal;
    mTmp,
    CurByte : Byte;
    BufIdx,
    CurC,
    YCount,
    XCount,
    mPalC   : Word;
 BEGIN
    IF (zWidth = 0) OR (zHeight = 0) THEN
      Exit;

    memset( H, SizeOf( H ), 0 );
    H.Mfg  := 10;
    H.Ver  := 5;
    H.Encoding := 1;
    H.BPP  := 8;
    H.X    := 0;
    H.Y    := 0;
    H.X2   := zWidth - 1;
    H.Y2   := zHeight - 1;
    H.XRes := zWidth;
    H.YRes := zHeight;
    H.NumPlanes := 1;
    H.BPL  := zWidth;
    H.PalType := 1;
    mResult := F^.BlockWrite( H, SizeOf( H ) );

    YCount := zHeight;
    BufIdx := 0;

    REPEAT
      XCount := zWidth;

      REPEAT
        CurC := 1;
        CurByte := Buf^[ BufIdx ];
        Inc( BufIdx );

        WHILE (Buf^[ BufIdx ] = CurByte) AND (XCount > 1) AND (CurC < 63) DO
        BEGIN
          Dec( XCount );
          Inc( CurC );
          Inc( BufIdx );
        END;

        IF (CurC > 1) OR (CurC >= $C0) THEN
        BEGIN
          mTmp := CurC + $C0;
          mResult := F^.BlockWrite( mTmp, 1 );
        END;

        mResult := F^.BlockWrite( CurByte, 1 );
        Dec( XCount );
      UNTIL (XCount = 0);

      Dec( YCount );
    UNTIL (YCount = 0) OR (BufIdx > (zWidth * zHeight));

    mTmp := $C;
    mResult := F^.BlockWrite( mTmp, 1 );

    FOR mPalC := 1 TO 768 DO
      zPal[ mPalC ] := zPal[ mPalC ] SHL 2;

    mResult := F^.BlockWrite( zPal, 768 );
  END;
END.
